#property indicator_chart_window

extern double risk = 1.0;
extern double stopLoss = 100;

int init()   { return (0); }
int deinit() { return (0); }

int start() 
{
   Comment(DoubleToStr(getLots(Symbol(),risk,stopLoss),3));
   return (0);
}  

double getLots(string symbol, double Risk, double stopLossDistance)
{
   RefreshRates();
   double lots     = 0;
   double MinLots  = NormalizeDouble(MarketInfo(symbol,MODE_MINLOT) ,2);
   double MaxLots  = NormalizeDouble(MarketInfo(symbol,MODE_MAXLOT) ,2);
   double LotStep  = NormalizeDouble(MarketInfo(symbol,MODE_LOTSTEP),2);
   int    LotDigit = 2;
         if(MarketInfo(symbol,MODE_DIGITS)==3 || MarketInfo(symbol,MODE_DIGITS)==5) stopLossDistance *= 10.0;

   //
   //
   //
   //
   //

    
      if (LotStep==1)    LotDigit=0;
      if (LotStep==0.1)  LotDigit=1;
      if (LotStep==0.01) LotDigit=2;
      if (Risk>0)
      {
         if (AccountBalance()>AccountFreeMargin())
               lots = NormalizeDouble(AccountFreeMargin()*(Risk/100.0)/(stopLossDistance*MarketInfo(symbol,MODE_TICKVALUE)),LotDigit);
         else  lots = NormalizeDouble(AccountBalance()   *(Risk/100.0)/(stopLossDistance*MarketInfo(symbol,MODE_TICKVALUE)),LotDigit);
      }
      
   //
   //
   //
   //    lots need to be normalized to accomodate lot step
   //    normalization does not rounds but cuts any portion of lot
   //    that is larger than lot step (that way the risk is a bit smaller)
   //
   //
      
   lots = NormalizeDouble(NormalizeDouble(lots/LotStep,0)*LotStep,LotDigit);
   lots = MathMax(MathMin(lots,MaxLots),MinLots);  
   return(lots);
}